﻿// Copyright (C) 2011 Oliver Sturm <oliver@oliversturm.com>. All rights reserved.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;

namespace AsyncAwaitBasics {
  class Program {
    static void Main(string[] args) {
      LoopFiveTimes( );
      while (true) {
        Console.WriteLine("Main program is alive!");
        Thread.Sleep(100);
      }
    }

    async static void LoopFiveTimes( ) {
      for (int i = 0; i < 5; i++) {
        await PrintWaitPrint( );
      }
    }

    async static Task PrintWaitPrint( ) {
      try {
        Console.WriteLine("First output from PrintWaitPrint, Task id=" + Task.CurrentId);
        await Task.Delay(1000);
        Console.WriteLine("Second output from PrintWaitPrint, Task id=" + Task.CurrentId);
      }
      finally {
        Console.WriteLine("Done with PrintWaitPrint");
      }
    }
  }
}
